SystemOrganization addCategory: #'OmniST-Tests-Core-Compiler'!
SystemOrganization addCategory: #'OmniST-Tests-Core-Reflection'!

OstDomain subclass: #OstCompilerTestDomain
	instanceVariableNames: 'record'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Core-Compiler'!

!OstCompilerTestDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/27/2011 17:23'!
initialize
	record := OrderedCollection new.! !

!OstCompilerTestDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/20/2012 21:30'!
readField: idx of: obj
	<omniDoNotTransform>
	record add: {#readField:of:. idx. obj}.
	^ obj instVarAt: idx! !

!OstCompilerTestDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/27/2011 17:31'!
record
	^ record! !

!OstCompilerTestDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/20/2012 21:30'!
requestExecution: selector of: anObj on: p1
	<omniDoNotTransform>
	record add: { #requestExecution:of:on:. selector asNormalSelector. anObj. p1 }.
	^ anObj perform: selector with: p1.
! !

!OstCompilerTestDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/20/2012 21:30'!
requestExecutionOf: selector on: anObj
	<omniDoNotTransform>
	record add: { #requestExecutionOf:on:. selector asNormalSelector. anObj }.
	^ anObj perform: selector
! !

!OstCompilerTestDomain methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/20/2012 21:30'!
write: val toField: idx of: obj
	<omniDoNotTransform>
	record add: {#write:toField:of:. val. idx. obj }.
	obj instVarAt: idx put: val.! !

OstObject subclass: #OstCompilerTestSubject
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Core-Compiler'!

!OstCompilerTestSubject class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/5/2012 21:16'!
returnSomeConstant
	^ #super! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
a
	^a! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
a: anA
	a := anA! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
aAndB
	^ a, b! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
b
	^b! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
b: anB
	b := anB! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:20'!
initialize
	a := #A.
	b := #B.
	c := #C.! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
return1
	^ 1! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
returnAViaTemp
	| oldA |
	oldA := a.
	^ oldA! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
returnNil
	^ nil! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
returnSelf
	^ self! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 1/5/2012 21:10'!
returnSomeConstant
	^ #super! !

!OstCompilerTestSubject methodsFor: 'methods for testing' stamp: 'StefanMarr 11/28/2011 14:21'!
somethingLongAndComplexReturningOriginalA
	| oldA and to |
	oldA := a.
	
	oldA = a ifTrue: [
		10 timesRepeat: [ a :=	#a ].
		
		and := c.
		to := b asString, c asString.
		
		"Will never happen".
		c == #abba
			ifTrue: [
				[a := self will never happen.].
				c := b + a + 10 factorial.]
			ifFalse: [
				[self this is always going to happen but this block will never be evaluated anyway,
				and we are just poluting the number of literals in this method,
				to make sure that we are not missing anything that should have been done by the compiler
				but is done wrong after we added our changes.].
				
				c := 1 + 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9 + 10.
			]
		].
	
	^ oldA! !

OstCompilerTestSubject subclass: #OstCompilerTestSubjectSub
	instanceVariableNames: 'd e f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Core-Compiler'!

!OstCompilerTestSubjectSub class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/5/2012 21:16'!
returnSomeConstant
	^ #sub! !

!OstCompilerTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 20:31'!
accessMixedFields
	^ { c. d. }! !

!OstCompilerTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 20:31'!
accessSubclassFields
	^ { d. e. f }! !

!OstCompilerTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 20:30'!
accessSuperClassFields
	^ { a. b }! !

!OstCompilerTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 12/12/2011 00:06'!
b
	^ super b! !

!OstCompilerTestSubjectSub methodsFor: 'initialization' stamp: 'StefanMarr 1/5/2012 20:32'!
initialize
	super initialize.
	d := #D.
	e := #E.
	f := #F.! !

!OstCompilerTestSubjectSub methodsFor: 'test helpers' stamp: 'StefanMarr 1/5/2012 21:10'!
returnSomeConstant
	^ #sub! !

TestCase subclass: #OstCompilerTest
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Core-Compiler'!

!OstCompilerTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/28/2011 13:17'!
basicReadOn: o
	self assert: 'AB' equals: o aAndB. " This one first since that is usually not optimizied by the compiler"

	self assert: #A equals: o a.
	self assert: #B equals: o b.! !

!OstCompilerTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/8/2011 22:39'!
basicReadOn: o in: aDomain
	" This one first since that is usually not optimizied by the compiler"

	self assert: 'AB' equals: ([ o aAndB ] omni: aDomain). 

	self assert: #A equals: ([ o a ] omni: aDomain).
	self assert: #B equals: ([ o b ] omni: aDomain).! !

!OstCompilerTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/27/2011 17:58'!
constReadOn: o
	self assert: 1 equals: o return1.
	self assert: nil equals: o returnNil.
	self assert: o equals: o returnSelf.! !

!OstCompilerTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/8/2011 22:39'!
constReadOn: o in: aDomain
	self assert: 1   equals: ([ o return1    ] omni: aDomain).
	self assert: nil equals: ([ o returnNil  ] omni: aDomain).
	self assert: o   equals: ([ o returnSelf ] omni: aDomain).! !

!OstCompilerTest methodsFor: 'testing' stamp: 'StefanMarr 3/20/2012 16:05'!
expectedFailures
	(Smalltalk hasClassNamed: #OstCompiler) 
		ifTrue: [^ #()]
		ifFalse:[^ #(testProcessClass)].
! !

!OstCompilerTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/27/2011 17:59'!
otherReadsOn: o
	self assert: #A equals: o returnAViaTemp.
	
	self assert: #A equals: o somethingLongAndComplexReturningOriginalA.! !

!OstCompilerTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/9/2011 16:31'!
otherReadsOn: o in: aDomain
	self assert: #A equals: ([ o returnAViaTemp ] omni: aDomain).
	
	self flag: 'TODO: check whether there is a way to get this one working, by reducing the number of created temp vars'.
	[self assert: #A equals: ([ o somethingLongAndComplexReturningOriginalA ] omni: aDomain).].! !

!OstCompilerTest methodsFor: 'running' stamp: 'StefanMarr 3/22/2012 11:42'!
setUp
	"Make sure they are compiled properly with OstCompiler.
	 We better do to much work then to few.
	 This is unfortunately executed for ever test."
	(Smalltalk hasClassNamed: #OstCompiler) ifTrue: [
		OstCompilerTestSubject compileAll.
		OstCompilerTest compileAll.
		OstCompilerTestDomain compileAll.
	].! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:57'!
testAllMethodSemanticsWithoutDomain
	| o |
	o := OstCompilerTestSubject new.
	
	OstMirror setDomainOf: o to: nil. "Not strictly necessary, but to be explicit"
	
	self basicReadOn:  o in: nil.
	self otherReadsOn: o in: nil.
	self constReadOn:  o in: nil.
	self writesOn:     o in: nil.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:58'!
testBasicReadWithDomain
	| o domain |
	o := OstCompilerTestSubject new.
	
	domain := OstCompilerTestDomain new.
	OstMirror setDomainOf: o to: domain.
	
	self basicReadOn: o in: domain.

	self assert: {#requestExecutionOf:on:. #aAndB. o } equals: domain record removeFirst.
	self assert: {#readField:of:. 2. o.} equals: domain record removeFirst.
	self assert: {#readField:of:. 3. o.} equals: domain record removeFirst.
	"All the little operations inbetween"
	21 timesRepeat: [domain record removeFirst].
	
	self assert: {#requestExecutionOf:on:. #a. o } equals: domain record removeFirst.
	self assert: {#readField:of:. 2. o.} equals: domain record removeFirst.
	
	self assert: {#requestExecutionOf:on:. #b. o } equals: domain record removeFirst.
	self assert: {#readField:of:. 3. o.} equals: domain record removeFirst.
	
! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:46'!
testBasicSend
	| result |
	result := [ 1 bitOr: 2 ] omni.
	self assert: 3 equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:53'!
testBasicSuperSend
	| o result d |
	o := OstCompilerTestSubjectSub new.
	d := OstCompilerTestDomain new.
	d adoptObject: o.
	result := [o b] omni: d.
	
	self assert: #B equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/15/2011 15:11'!
testCascadedNotInSequence
	| assoc |
	assoc := Association key: #foo value: 0.
	[ assoc value: (assoc value: 1;
	                      value: 2) ] omni.

	self assert: assoc == assoc value.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/13/2011 12:46'!
testCascadedOnComplexExpression2Sends
	| assoc |
	assoc := Association key: #foo value: 0.
	[ (assoc value: 3) value: (1 + 2);
			 value: assoc value + 2;
			 value: assoc value + 5 ] omni.

	self assert: 10 equals: assoc value.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/13/2011 12:45'!
testCascadedOnComplexExpressionSends
	| assoc |
	
	[ (assoc := Association key: #foo value: 0) value: (1 + 2);
			 value: assoc value + 2;
			 value: assoc value + 5 ] omni.

	self assert: 10 equals: assoc value.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/15/2011 14:59'!
testCascadedSends
	| assoc |
	assoc := Association key: #foo value: 0.
	
	[ assoc value: (1 + 2);
			 value: assoc value + 2;
			 value: assoc value + 5 ] omni.

	self assert: 10 equals: assoc value.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:49'!
testChainedAndComplexArgumentSend
	| result |
	result := [ (1 bitOr: 2) bitOr: (8 bitOr: 16) ] omni.
	self assert: 27 equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:47'!
testChainedSend
	| result |
	result := [ (1 bitOr: 2) bitOr: 4 ] omni.
	self assert: 7 equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/21/2012 18:08'!
testClosureAndInits
	| result |

	[ | o |

		o := OstCompilerTestSubjectSub new.
		result := o ] omni.
	
	self assert: result notNil
! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/21/2012 18:05'!
testClosures
	| result |
	
	[ | o |
		o := Object new.
		result := o. ] omni.
	
	self assert: result notNil.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 12/8/2011 23:49'!
testComplexArgumentSend
	| result |
	result := [ 1 bitOr: (8 bitOr: 16) ] omni.
	self assert: 25 equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:58'!
testConstReadWithDomain
	| o domain |
	o := OstCompilerTestSubject new.
	
	domain := OstCompilerTestDomain new.
	OstMirror setDomainOf: o to: domain.
	
	self constReadOn: o in: domain.
		
	self assert: {#requestExecutionOf:on:. #return1.    o} equals: domain record removeFirst.
	self assert: {#requestExecutionOf:on:. #returnNil.  o} equals: domain record removeFirst.
	self assert: {#requestExecutionOf:on:. #returnSelf. o} equals: domain record removeFirst.
	! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:59'!
testOtherReadsWithDomain
	| o domain |
	o := OstCompilerTestSubject new.
	
	domain := OstCompilerTestDomain new.
	OstMirror setDomainOf: o to: domain.
	
	self otherReadsOn: o in: domain.
	
	self assert: {#requestExecutionOf:on:. #returnAViaTemp. o } equals: domain record removeFirst.
	self assert: {#readField:of:. 2. o.} equals: domain record removeFirst.
	
	
	self flag: 'TODO: currently disabled since this test does not fit into the temp boundaries of smalltalk :('.
	[ self assert: {#requestExecutionOf:on:. #somethingLongAndComplexReturningOriginalA. o. }
	     equals: domain record removeFirst.
     self assert: {#readField:of:. 2. o.} equals: domain record removeFirst.].
	! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 16:06'!
testProcessClass
	"The loading and cross-updating sometimes leads for some reason
	 to the disappearing of the omniDomain instance variable.
	
	 REM: If this test fails, execute:
		 OstDomain initialize.
	 Or make sure that you run on an OmniVM. "
	self assert: (Process hasInstVarNamed: #omniDomain)! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 1/5/2012 21:12'!
testProperOmnificationInClassHierarchy
	| o result |
	o := OstCompilerTestSubject new.
	
	result := [o returnSomeConstant] omni.
	
	self assert: #super equals: result.
	
	o := OstCompilerTestSubjectSub new.
	result := [o returnSomeConstant] omni.
	
	self assert: #sub equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 1/5/2012 21:17'!
testProperOmnificationInClassHierarchyOnClassSide
	| result |
	result := [OstCompilerTestSubject returnSomeConstant] omni.
	
	self assert: #super equals: result.
	
	result := [OstCompilerTestSubjectSub returnSomeConstant] omni.
	
	self assert: #sub equals: result.! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 1/5/2012 20:42'!
testReadInMixedClasses
	| result |
	
	[ | o |
		o := OstCompilerTestSubjectSub new.
		result := o accessMixedFields. ] omni.
	
	self assert: #C equals: (result at: 1).
	self assert: #D equals: (result at: 2).! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 1/5/2012 20:43'!
testReadInSubClass
	| result |
	
	[ | o |
		o := OstCompilerTestSubjectSub new.
		result := o accessSubclassFields. ] omni.
	
	self assert: #D equals: (result at: 1).
	self assert: #E equals: (result at: 2).
	self assert: #F equals: (result at: 3).! !

!OstCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 1/5/2012 20:42'!
testReadInSuperClass
	| result |
	
	[ | o |
		o := OstCompilerTestSubjectSub new.
		result := o accessSuperClassFields. ] omni.
	
	self assert: #A equals: (result at: 1).
	self assert: #B equals: (result at: 2).! !

!OstCompilerTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/27/2011 17:59'!
writesOn: o
	self deny: (o a = 42).
	o a: 42.
	self assert: 42 equals: o a.
	
	self deny: (o b = 55).
	o b: 55.
	self assert: 55 equals: o b.
	! !

!OstCompilerTest methodsFor: 'test helpers' stamp: 'StefanMarr 12/8/2011 22:41'!
writesOn: o in: aDomain
	self deny: (o a = 42).
	o a: 42.
	self assert: 42 equals: ([o a] omni: aDomain).
	
	self deny: (o b = 55).
	o b: 55.
	self assert: 55 equals: ([o b] omni: aDomain).
	! !

TestCase subclass: #OstCompilerUtilitiesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Core-Compiler'!

!OstCompilerUtilitiesTest methodsFor: 'testing' stamp: 'StefanMarr 3/20/2012 16:09'!
expectedFailures
	(Smalltalk hasClassNamed: #OstCompiler) 
		ifTrue: [^ #()]
		ifFalse:[^ #(testAsNormalSelector
						testAsOmniSelector
						testIsInfix
						testIsOmniSelector
						testIsUnary
						testNumArgs)].
! !

!OstCompilerUtilitiesTest methodsFor: 'testing' stamp: 'StefanMarr 12/11/2011 16:47'!
testAsNormalSelector
	self assert: #'xx_omni_x_string' asNormalSelector == #string.
	self assert: #'xx_omni_x_linesDo:' asNormalSelector == #linesDo:.
	self assert: #'xx_omni_x_indexOf:startingAt:' asNormalSelector == #indexOf:startingAt:.
	self assert: #'xx_omni_x_//' asNormalSelector == #//! !

!OstCompilerUtilitiesTest methodsFor: 'testing' stamp: 'StefanMarr 12/11/2011 16:47'!
testAsOmniSelector
	self assert: #string asOmniSelector == #'xx_omni_x_string'.
	self assert: #linesDo: asOmniSelector == #'xx_omni_x_linesDo:'.
	self assert: #indexOf:startingAt: asOmniSelector == #'xx_omni_x_indexOf:startingAt:'.
	self assert: #// asOmniSelector == #'xx_omni_x_//'! !

!OstCompilerUtilitiesTest methodsFor: 'testing-symbol' stamp: 'StefanMarr 12/11/2011 16:47'!
testIsInfix
	self deny: #string isInfix.
	self deny: #'xx_omni_x_string' isInfix.
	
	self deny: #linesDo: isInfix.
	self deny: #'xx_omni_x_linesDo:' isInfix.
	
	self deny: #indexOf:startingAt: isInfix.
	self deny: #'xx_omni_x_indexOf:startingAt:' isInfix.
	
	self assert: #// isInfix.
	self assert: #'xx_omni_x_//' isInfix! !

!OstCompilerUtilitiesTest methodsFor: 'testing-symbol' stamp: 'StefanMarr 12/11/2011 16:48'!
testIsKeyword
	self deny: #string isKeyword.
	self deny: #'xx_omni_x_string' isKeyword.
	
	self assert: #linesDo: isKeyword.
	self assert: #'xx_omni_x_linesDo:' isKeyword.
	
	self assert: #indexOf:startingAt: isKeyword.
	self assert: #'xx_omni_x_indexOf:startingAt:' isKeyword.
	
	self deny: #// isKeyword.
	self deny: #'xx_omni_x_//' isKeyword! !

!OstCompilerUtilitiesTest methodsFor: 'testing' stamp: 'StefanMarr 12/11/2011 17:18'!
testIsOmniSelector
	self deny: #string isOmniSelector.
	self deny: #linesDo: isOmniSelector.
	self deny: #indexOf:startingAt: isOmniSelector.
	self deny: #// isOmniSelector.

	self assert: #'xx_omni_x_string' isOmniSelector.
	self assert: #'xx_omni_x_linesDo:' isOmniSelector.
	self assert: #'xx_omni_x_indexOf:startingAt:' isOmniSelector.
	self assert: #'xx_omni_x_//:' isOmniSelector! !

!OstCompilerUtilitiesTest methodsFor: 'testing-symbol' stamp: 'StefanMarr 12/11/2011 16:48'!
testIsUnary
	self assert: #string isUnary.
	self assert: #'xx_omni_x_string' isUnary.
	
	self deny: #linesDo: isUnary.
	self deny: #'xx_omni_x_linesDo:' isUnary.
	
	self deny: #indexOf:startingAt: isUnary.
	self deny: #'xx_omni_x_indexOf:startingAt:' isUnary.
	
	self deny: #// isUnary.
	self deny: #'xx_omni_x_//' isUnary! !

!OstCompilerUtilitiesTest methodsFor: 'testing-symbol' stamp: 'StefanMarr 12/11/2011 16:49'!
testNumArgs
	self assert: #string numArgs = 0.
	self assert: #'xx_omni_x_string' numArgs = 0.
	
	self assert: #linesDo: numArgs = 1.
	self assert: #'xx_omni_x_linesDo:' numArgs = 1.
	
	self assert: #indexOf:startingAt: numArgs = 2.
	self assert: #'xx_omni_x_indexOf:startingAt:' numArgs = 2.
	
	self assert: #// numArgs = 1.
	self assert: #'xx_omni_x_//' numArgs = 1! !

TestCase subclass: #OstDomainTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Core-Reflection'!

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:50'!
testAdoptObject
	| domain hello |
	domain := OstDomain new.
	
	hello := OstObject new.
	
	self assert: nil equals: (OstMirror domainOf: hello).
	
	domain adoptObject: hello.
	
	self assert: domain equals: (OstMirror domainOf: hello).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:50'!
testDomainForNewObjectsNotUsedWithoutOmnification
	| domain hello |
	domain := OstDomain new.
	
	hello := domain evaluateInContext: [ OstObject new. ].
	
	"This is expected behavior because omnification is not enabled for #evaluateInContext:"
	self assert: nil equals: (OstMirror domainOf: hello).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/22/2012 14:50'!
testDomainForNewObjectsWithOmnification
	| domain hello |
	domain := OstDomain new.
	
	hello := [ OstObject new. ] omni: domain.
	
	"This should work since we used the #omni: entry."
	self assert: domain equals: (OstMirror domainOf: hello).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 1/3/2012 13:23'!
testEvaluateInContext
	| domain result |
	domain := OstDomain new.
	
	"We just use the array to be sure that we got the result of the block and nothing else"
	result := domain evaluateInContext: [ { OstDomain currentDomain } ].
	
	self assert: domain equals: (result at: 1).! !

!OstDomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/20/2012 15:50'!
testNewProcessFor
	| domain  promise block proc |
	domain := OstDomain new.
	
	promise := OPromise new.
	block := [ promise deliver: (OstDomain currentDomain) ].
	
	proc := domain newProcessFor: block.
	
	self assert: (proc isKindOf: Process).
	self assert: domain equals: (OstMirror domainOf: proc).
	
	proc resume.
	self assert: domain equals: promise read.! !
